using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace TestMainWindow
{
    public class NcCalendarControl : Control
    {
        #region 캯
        static NcCalendarControl()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(NcCalendarControl), new FrameworkPropertyMetadata(typeof(NcCalendarControl)));
            CommandManager.RegisterClassCommandBinding(typeof(NcCalendarControl), new CommandBinding(PreviousYear, OnPreviousYear));
            CommandManager.RegisterClassCommandBinding(typeof(NcCalendarControl), new CommandBinding(PreviousMonth, OnPreviousMonth));
            CommandManager.RegisterClassCommandBinding(typeof(NcCalendarControl), new CommandBinding(NextYear, OnNextYear));
            CommandManager.RegisterClassCommandBinding(typeof(NcCalendarControl), new CommandBinding(NextMonth, OnNextMonth));
            CommandManager.RegisterClassCommandBinding(typeof(NcCalendarControl), new CommandBinding(Today, OnToday));
        }
        public NcCalendarControl() 
        {
            this.SetValue(ItemsProperty, new NcCalendar(DateTime.Now));
            Items.SelectedChanged += new EventHandler(Items_SelectedChanged);
        }
        #endregion

        #region Զ
        /// <summary>
        /// µ"" 
        /// </summary>
        public NcCalendar Items
        {
            get { return (NcCalendar)GetValue(ItemsProperty); }
            set { SetValue(ItemsProperty, value); }
        }
        public static readonly DependencyProperty ItemsProperty = DependencyProperty.Register("Items", typeof(NcCalendar), typeof(NcCalendarControl), new UIPropertyMetadata(new NcCalendar(DateTime.Now)));

        #region Changeable
        /// <summary>
        /// Ƿܹͨťıꡢ¡
        /// </summary>
        public static readonly DependencyProperty ChangeableProperty = DependencyProperty.Register("Changeable", typeof(bool), typeof(NcCalendarControl), new FrameworkPropertyMetadata(true));
        /// <summary>
        /// ȡChangeable
        /// </summary>
        public bool Changeable
        {
            get { return (bool)base.GetValue(NcCalendarControl.ChangeableProperty); }
            set { base.SetValue(NcCalendarControl.ChangeableProperty, value); }
        }
        #endregion

        #region ShowHeader
        /// <summary>
        /// Ƿʾͷ
        /// </summary>
        public static readonly DependencyProperty ShowHeaderProperty = DependencyProperty.Register("ShowHeader", typeof(bool), typeof(NcCalendarControl), new FrameworkPropertyMetadata(true));
        /// <summary>
        /// ȡShowHeader
        /// </summary>
        public bool ShowHeader
        {
            get { return (bool)base.GetValue(NcCalendarControl.ShowHeaderProperty); }
            set { base.SetValue(NcCalendarControl.ShowHeaderProperty, value); }
        }
        #endregion

        #region ShowWeekTitle
        /// <summary>
        /// Ƿʾܱǩ
        /// </summary>
        public static readonly DependencyProperty ShowWeekTitleProperty = DependencyProperty.Register("ShowWeekTitle", typeof(bool), typeof(NcCalendarControl), new FrameworkPropertyMetadata(true));
        /// <summary>
        /// ȡShowWeekTitle
        /// </summary>
        public bool ShowWeekTitle
        {
            get { return (bool)base.GetValue(NcCalendarControl.ShowWeekTitleProperty); }
            set { base.SetValue(NcCalendarControl.ShowWeekTitleProperty, value); }
        }
        #endregion

        #region CurrentDay
        /// <summary>
        /// ȡCurrentDayʶ
        /// </summary>
        public static readonly DependencyPropertyKey CurrentDayPropertyKey = DependencyProperty.RegisterReadOnly("CurrentDay", typeof(DateTime), typeof(NcCalendarControl), new FrameworkPropertyMetadata(DateTime.Now.Date));
        /// <summary>
        /// ȡCurrentDay
        /// </summary>
        public static readonly DependencyProperty CurrentDayProperty = CurrentDayPropertyKey.DependencyProperty;
        /// <summary>
        /// ȡCurrentDay
        /// </summary>
        public DateTime CurrentDay { get { return (DateTime)base.GetValue(NcCalendarControl.CurrentDayProperty); } }
        #endregion
        #endregion

        #region ¼
        /// <summary>
        /// ѡı¼
        /// </summary>
        public static readonly RoutedEvent SelectedChangedEvent = EventManager.RegisterRoutedEvent("SelectedChanged", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(NcCalendarControl));
        public event RoutedEventHandler SelectedChanged
        {
            add { AddHandler(SelectedChangedEvent, value); }
            remove { RemoveHandler(SelectedChangedEvent, value); }
        }
        void RaiseSelectedChangedEvent()
        {
            RoutedEventArgs args = new RoutedEventArgs(SelectedChangedEvent,this);
            RaiseEvent(args);
        }
        #endregion

        #region 
        #region PreviousYear
        /// <summary>
        /// ͼǰƶһ
        /// </summary>
        public static RoutedUICommand PreviousYear { get { return mPreviousYear; } }
        private static RoutedUICommand mPreviousYear = new RoutedUICommand("PreviousYear", "PreviousYear", typeof(NcCalendarControl));

        private static void OnPreviousYear(object sender, ExecutedRoutedEventArgs e)
        {
            NcCalendarControl calendar = sender as NcCalendarControl;
            if (calendar == null) return;
            calendar.Items.PreviousYear();
        }
        #endregion
        #region NextYear
        /// <summary>
        /// ͼƶһ
        /// </summary>
        public static RoutedUICommand NextYear { get { return mNextYear; } }
        private static RoutedUICommand mNextYear = new RoutedUICommand("NextYear", "NextYear", typeof(NcCalendarControl));

        private static void OnNextYear(object sender, ExecutedRoutedEventArgs e)
        {
            NcCalendarControl calendar = sender as NcCalendarControl;
            if (calendar == null) return;
            calendar.Items.NextYear();
        }
        #endregion
        #region PreviousMonth
        /// <summary>
        /// ͼǰƶһ
        /// </summary>
        public static RoutedUICommand PreviousMonth { get { return mPreviousMonth; } }
        private static RoutedUICommand mPreviousMonth = new RoutedUICommand("PreviousMonth", "PreviousMonth", typeof(NcCalendarControl));

        private static void OnPreviousMonth(object sender, ExecutedRoutedEventArgs e)
        {
            NcCalendarControl calendar = sender as NcCalendarControl;
            if (calendar == null) return;
            calendar.Items.PreviousMonth();
        }
        #endregion
        #region NextMonth
        /// <summary>
        /// ͼƶһ
        /// </summary>
        public static RoutedUICommand NextMonth { get { return mNextMonth; } }
        private static RoutedUICommand mNextMonth = new RoutedUICommand("NextMonth", "NextMonth", typeof(NcCalendarControl));

        private static void OnNextMonth(object sender, ExecutedRoutedEventArgs e)
        {
            NcCalendarControl calendar = sender as NcCalendarControl;
            if (calendar == null) return;
            calendar.Items.NextMonth();
        }
        #endregion
        #region Today
        /// <summary>
        /// ת
        /// </summary>
        public static RoutedUICommand Today { get { return mToday; } }
        private static RoutedUICommand mToday = new RoutedUICommand("Today", "Today", typeof(NcCalendarControl));
        private static void OnToday(object sender, ExecutedRoutedEventArgs e)
        {
            NcCalendarControl calendar = sender as NcCalendarControl;
            if (calendar == null) return;
            calendar.Items.Today();
            DateTime dt = calendar.CurrentDay.Date;
            // XAMLеĿؼҪĽ ??????????????????????????
            List<RadioButton> rbList = new List<RadioButton>();
            calendar.FindRadioButton(calendar, rbList);
            foreach(RadioButton one in rbList )
            {
                NcCalendarDay day = one.DataContext as NcCalendarDay;
                if (day != null && day.Value.Date == dt.Date)
                {
                    one.Focus();
                    break;
                }
            }
        }
        /// <summary>
        /// ͼеġ족ť
        /// </summary>
        /// <param name="parent"></param>
        /// <param name="rbList"></param>
        private void FindRadioButton(DependencyObject parent, List<RadioButton> rbList)
        {
            int childrenCount = VisualTreeHelper.GetChildrenCount(parent);
            for (int i = 0; i < childrenCount; i++)
            {
                DependencyObject obj = VisualTreeHelper.GetChild(parent, i);
                if (obj.GetType() == typeof(RadioButton))
                {
                    RadioButton rb = obj as RadioButton;
                    if (rb != null) rbList.Add(rb);

                    //NcCalendarDay day = rb.Content as NcCalendarDay;
                    //if (day != null && day.Value.Date == dt.Date)
                    //{
                    //    rb.Focus();
                    //    break;
                    //}
                }
                else
                    FindRadioButton(obj, rbList);
            }

        }
        #endregion
        #endregion

        /// <summary>
        /// ÿؼĵǰڡڲڵǰʾ·ݣǰͼΪָڵ·ͼ
        /// </summary>
        /// <param name="date">ڡ</param>
        public void SetValue(DateTime date) { if (date != null) Items.SetValue(date); }

        /// <summary>
        /// ѡı¼
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Items_SelectedChanged(object sender, EventArgs e)
        {
            if (Items.Current == null || Items.Current == NcCalendarDay.Empty) return;
            DateTime dt = Items.Current.Value;
            this.SetValue(NcCalendarControl.CurrentDayPropertyKey, dt);
            RaiseSelectedChangedEvent();
        }
    }
}
